# 更新日志

## 1.15.0

- 修复部分只有 `HLS` 流的直播不能自动录制 (issue #183)
- 没有 `flv` 流切换录制 `fmp4` 流 （issue #169）
- 修复 `RuntimeError: cannot join current thread`（issue #161）
- 修复 `Unclosed client session` (issue #176)
- 添加测试 `cookie` 的功能 (issue #181)

## 1.14.1

修复 `ModuleNotFoundError: No module named 'blrec.web.middlewares'`

## 1.14.0

- 修复删除全部任务失败
- 支持反代到子目录
- 环境变量全部添加 `BLREC_` 前缀
- 支持在终端隐藏进度条，`Docker` 默认隐藏。
- 修复 _时长限制_ 和 _大小限制_ 设置显示异常
- 添加 `CoverImageDownloadedEvent` 和 `PostprocessingCompletedEvent` 两个事件
- `Docker` 添加对 `Linux/ARM64` 平台的支持
- 修复添加 `cookie` 后弹幕 `uid` 和用户名仍被屏蔽

## 1.13.0

- 支持 Python 3.11
- 改进直播监控 
- 优化在 Linux 下的内存占用
- docker 时区设置为默认 `Asia/Shanghai`

## 1.12.0

- 支持自定义 Telegram bot api 地址 
- 重构弹幕客户端: 避免接收的数据有问题导致崩溃，调整弹幕接收超时时间。

## 1.11.1

- 修复 `meta.json` 文件没被删除

## 1.11.0

- 改善 HLS 标准录制模式的稳定性
- 兼容禁用弹幕的直播间
- 支持 Bark 通知
- 日志文件改为按天分割

## 1.10.0

- 设置 umask 为 000 以确保创建的文件夹权限为 777
- 在弹幕文件里保存续费舰长消息 (USER_TOAST_MSG)
- 修复 webui 文件详情显示错误
- 重构 HLS 原始录制模式部分代码 （可能修复了录制意外终止的 bug ？）
- 自定义 B 站 API 主机地址

## 1.9.1

- 修复禁用硬盘空间检测出现 cpu 占用异常

## 1.9.0

- 录制 HLS(fmp4) 原始数据
- 可以禁用硬盘空间检测
- 自定义自动文件分割的大小和时长

## 1.8.1

修 bug

## 1.8.0

- 重构直播流录制
- 重构弹幕客户端
- 修复了一些 bug
- 优先使用 web api
- 添加直播流时间相关元数据
- 支持 Liquid 模板自定义通知消息
- 同一时间只处理一个录播文件
- 流录制中断重新调整弹幕时间
- 对流主机进行排序

## 1.8.0-alpha.5

- 流录制中断重新调整弹幕时间
- 重构并修正了一些问题

## 1.8.0-alpha.4

- 改善录制多个直播间出现卡顿

## 1.8.0-alpha.3

- 重构并修正了一些问题
- 添加直播流时间相关元数据
- 支持 Liquid 模板自定义通知消息

## 1.8.0-alpha.2

- 重构弹幕客户端
- 修复弹幕接收

## 1.8.0-alpha.1

- 重构
- 修 bug

## 1.8.0-alpha

- 重构直播流录制
- 修复一些 bug
- 优先使用 web api

## 1.7.1

修正 pushkey 验证

## 1.7.0

- 添加封面保存策略
- 添加 Telegram bot 通知
- 添加 PushDeer 通知
- 废弃录制 HLS(ts) 流
- 在设定时间内没有 fmp4 流自动切换录制 flv 流

### P.S.

录制 fmp4 流基本没什么问题了

录制 fmp4 流基本不受网络波动影响，大概是不会录制到二压画质的。

人气比较高会被二压的直播间大都是有 fmp4 流的。

WEB 端直播播放器是 `Hls7Player` 的直播间支持录制 fmp4 流, `fMp4Player` 则不支持。

## 1.6.2

- 忽略 Windows 注册表 JavaScript MIME 设置 (issue #12, 27)
- 修复 HLS 录制出错 (issue #39, 41)
- 修 bug (issue #47)
- Windows 绿色版默认主机绑定 0.0.0.0 并加上 api key

## 1.6.1

- 修复 bug (issue #37, 38, 40)
- 接收到错误的数据自动换线路 (issue #43)

## 1.6.0

- 更新 Pushplus 消息推送 url (issue #26)
- 邮箱通知支持 STARTTLS (issue #35)
- 超时没接收到推流事件弹幕自动开始录制流 (issue #31, #36)
- 增加一个源文件删除策略
- 添加并优先使用 APP API (缓解被 ban 的几率)
- 改进启动时任务加载 (不用等加载完才可访问)
- 支持录制 HLS 直播流 (实验性)
- 去掉一行最多显示 3 个任务卡片的限制 (网格布局自适应)
- 在任务卡片上显示录制信息 (从任务卡片右下角菜单打开)
- 任务详情页面添加网络详情和图表

### P.S.

支持录制 HLS 直播流需要 ffmpeg，获取直播流信息需要 ffprobe。

从命令行运行需自行安装 ffmpeg 和 ffprobe， docker 和绿色版已内置不需要安装。

## 1.6.0-alpha

- REST API 支持获取正在录制的 flv 文件的路径和元数据

## 1.5.0

- 支持设置日志文件存放位置
- Docker 支持修改日志文件和录播文件存放位置

## 1.4.0

- 适应数据有问题的流服务器 gotcha08 (issue #13)
- 支持 Docker (issue #15)
- 修复弹幕录制出错 (issue #16)
- 弹幕文件统一礼物价格单位 (issue #18)
- Webhook 支持更多事件  (issue #19)
- 文件名重复自动加后缀 (issue #20)
- 记录免费礼物到弹幕文件为可选的
- 加强 api-key 的安全性
- 其它一些重构调整

## 1.3.2

- 修复录制错误： `AssertionError: Invalid Tag`
- 修复前端 https 下不能显示主播头像

## 1.3.1

- 修复没成功修复的录制异常 `IndexError: list index out of range`

## 1.3.0

### 功能

- flv 添加关键帧元数据为可选功能
- 支持保存直播间封面
- 断网超过设置的等待时间自动结束录制
- 断网后网络恢复且未下播自动重新开始录制

### 修复

- 修复录制异常 `IndexError: list index out of range`
- 修复关闭录制后没有更新元数据或转封装

## 1.2.4

- 修复回收空间时文件不存在异常
- 修复章节标记时间异常导致转封装出错

## 1.2.3

- 修复直播间标题有特殊字符导致文件创建失败
- 修复弹幕有特殊字符导致弹幕录制出错

## 1.2.2

- 避免 url 失效出现一直超时不能录制

## 1.2.1

- 兼容 flv 头不正确的直播流

## 1.2.0

- 改进文件处理方式，文件录制完成后就进行处理。
- 支持手动分割文件（单击任务卡片左下角剪刀图标）
- 添加任务详情页面（单击任务卡片的封面图进入）
- 修复 FastApi 文档页面访问不了

## 1.1.0

- 支持记录送物、上舰、醒目留言到弹幕文件
- 支持保存原始弹幕为 JSON lines 文件
- 弹幕协议更新了，更新弹幕客户端支持新的弹幕协议。
- 对前端界面样式做了些微调整

## 1.0.5

- 修复路径模板设置的模板变量显示不完整
- 修复主机绑定不是 localhost 自动打开浏览器访问出错
- 其它一些重构调整

## 1.0.4

- 兼容 SRT 推流

## 1.0.3

- 修复 bug

## 1.0.2

- 修复版本号没有更新~

## 1.0.1

- 修复了一个小 bug

## 1.0.0

- 第一个正式版发布
